
set server TIASQl
/

remark
\
,       "...."
/


connect PEAK9999 sysadm/sysadm
/

remark
\
,    -  ,    ""   
   ...
/

CREATE TABLE SYSADM.GROS_BUCH (
  ID VARCHAR(18) NOT NULL, 
  ROW_DATE DATE, 
  ID_D_ACC VARCHAR(18), 
  ID_K_ACC VARCHAR(18), 
  ID_AN_D VARCHAR(18), 
  ID_AN_K VARCHAR(18), 
  DEFIneRow VARCHAR(18), 
  Money_ROW DOUBLE PRECISION, 
  quanti_ROW DOUBLE PRECISION, 
  NUMJOURNAL VARCHAR(10), 
  ID_CUR VARCHAR(18), 
  ID_DOC VARCHAR(18), 
  ID_STR_DOC VARCHAR(18), 
  ID_USER VARCHAR(18) NOT NULL)
/

CREATE UNIQUE INDEX SYSADM.INDDB01 ON SYSADM.GROS_BUCH(
  ID)
/
CREATE INDEX SYSADM.INDDB12 ON SYSADM.GROS_BUCH(
 DEFIneRow )
/
CREATE INDEX SYSADM.INDDB13 ON SYSADM.GROS_BUCH(
  ID_USER)
/
CREATE INDEX SYSADM.INDGB02 ON SYSADM.GROS_BUCH(
 ROW_DATE )
/
CREATE INDEX SYSADM.INDGB03 ON SYSADM.GROS_BUCH(
  ID_D_ACC)
/
CREATE INDEX SYSADM.INDGB04 ON SYSADM.GROS_BUCH(
  ID_K_ACC)
/
CREATE INDEX SYSADM.INDGB05 ON SYSADM.GROS_BUCH(
  Money_ROW)
/

CREATE INDEX SYSADM.INDGB14 ON SYSADM.GROS_BUCH(
quanti_ROW )
/
CREATE INDEX SYSADM.INDGB06 ON SYSADM.GROS_BUCH(
  ID_CUR)
/
CREATE INDEX SYSADM.INDGB07 ON SYSADM.GROS_BUCH(
  ID_AN_D)
/
CREATE INDEX SYSADM.INDGB08 ON SYSADM.GROS_BUCH(
  ID_AN_K)
/
CREATE INDEX SYSADM.INDGB09 ON SYSADM.GROS_BUCH(
  ID_DOC)
/
CREATE INDEX SYSADM.INDGB10 ON SYSADM.GROS_BUCH(
  ID_STR_DOC)
/
CREATE PUBLIC SYNONYM GROS_BUCH FOR SYSADM.GROS_BUCH
/


ALTER TABLE SYSADM.GROS_BUCH FOREIGN KEY GrBu001 (
  DEFIneRow ) REFERENCES SYSADM.CONSTCHAR
/ 

ALTER TABLE SYSADM.GROS_BUCH FOREIGN KEY GrBu002 (
  ID_DOC ) REFERENCES SYSADM.LISTDOC
/ 

ALTER TABLE SYSADM.GROS_BUCH FOREIGN KEY LU120603 (
  ID_USER) REFERENCES SYSADM.LISTUSER
/

CREATE TABLE SYSADM.PLAN_ACCOUNT (
  ID VARCHAR(18) NOT NULL, 
  ACCOUNT VARCHAR(16), 
  DEFINE VARCHAR(50), 
  ANALITIC VARCHAR(18), 
  ACCLINCK VARCHAR(18), 
  FLAGS CHAR(4))
/

CREATE UNIQUE INDEX SYSADM.PLACC01 ON SYSADM.PLAN_ACCOUNT(
  ID)
/
CREATE INDEX SYSADM.PLACC03 ON SYSADM.PLAN_ACCOUNT(
  ANALITIC)
/
CREATE INDEX SYSADM.PLACC04 ON SYSADM.PLAN_ACCOUNT(
  ACCLINCK)
/
CREATE INDEX SYSADM.PLACC05 ON SYSADM.PLAN_ACCOUNT(
  DEFINE)
/
CREATE INDEX SYSADM.PLACC02 ON SYSADM.PLAN_ACCOUNT(
ACCOUNT )
/

ALTER TABLE SYSADM.PLAN_ACCOUNT PRIMARY KEY (
  ID)
/

ALTER TABLE SYSADM.GROS_BUCH FOREIGN KEY GB100401 (
  ID_D_ACC) REFERENCES SYSADM.PLAN_ACCOUNT
/
ALTER TABLE SYSADM.GROS_BUCH FOREIGN KEY GB100402 (
  ID_K_ACC) REFERENCES SYSADM.PLAN_ACCOUNT
/
CREATE PUBLIC SYNONYM PLAN_ACCOUNT FOR SYSADM.PLAN_ACCOUNT
/


CREATE TABLE SYSADM.SUBCONTO (
  ID VARCHAR(18) NOT NULL, 
  NAME CHAR(50), 
  STORY VARCHAR(254), 
  FLAGS DOUBLE PRECISION, 
  IDSTRUCT VARCHAR(18), 
  IDPARAM VARCHAR(18))
/

CREATE UNIQUE INDEX SYSADM.IDSUBCO01 ON SYSADM.SUBCONTO(
  ID)
/
CREATE INDEX SYSADM.IDSUBCO02 ON SYSADM.SUBCONTO(
  IDSTRUCT)
/
CREATE INDEX SYSADM.IDSUBCO03 ON SYSADM.SUBCONTO(
  NAME)
/
CREATE INDEX SYSADM.IDSUBCO04 ON SYSADM.SUBCONTO(
  IDPARAM)
/

ALTER TABLE SYSADM.SUBCONTO PRIMARY KEY (
  ID)
/

ALTER TABLE SYSADM.PLAN_ACCOUNT FOREIGN KEY PA100400 (
  ANALITIC ) REFERENCES SYSADM.SUBCONTO
/
ALTER TABLE SYSADM.PLAN_ACCOUNT FOREIGN KEY PA100401 (
  ACCLINCK ) REFERENCES SYSADM.SUBCONTO
/

ALTER TABLE SYSADM.GROS_BUCH FOREIGN KEY SU100401 (
  ID_AN_D) REFERENCES SYSADM.SUBCONTO
/
ALTER TABLE SYSADM.GROS_BUCH FOREIGN KEY SU100402 (
  ID_AN_K) REFERENCES SYSADM.SUBCONTO
/

ALTER TABLE SYSADM.LISTRIGTHUS FOREIGN KEY SB100400 (
  IDSUBC ) REFERENCES SYSADM.SUBCONTO
/
CREATE PUBLIC SYNONYM SUBCONTO FOR SYSADM.SUBCONTO
/


CREATE TABLE SYSADM.CURRENCY (
  ID VARCHAR(18) NOT NULL, 
  NAME_CUR VARCHAR(25), 
  DEF_CUR VARCHAR(5))
/

CREATE UNIQUE INDEX SYSADM.Cur001 ON SYSADM.CURRENCY(
  ID)
/
CREATE UNIQUE INDEX SYSADM.Cur002 ON SYSADM.CURRENCY(
  NAME_CUR )
/
CREATE UNIQUE INDEX SYSADM.Cur003 ON SYSADM.CURRENCY(
  DEF_CUR )
/

ALTER TABLE SYSADM.CURRENCY PRIMARY KEY (
  ID)
/

ALTER TABLE SYSADM.GROS_BUCH FOREIGN KEY CU100401 (
  ID_CUR) REFERENCES SYSADM.CURRENCY
/

CREATE PUBLIC SYNONYM CURRENCY FOR SYSADM.CURRENCY
/


CREATE TABLE SYSADM.CROSSCUR (
  ID VARCHAR(18) NOT NULL, 
  ROW_DATE DATE, 
  ID_CUR1 VARCHAR(18), 
  SUM_C DOUBLE PRECISION, 
  ID_CUR2 VARCHAR(18))
/
CREATE UNIQUE INDEX SYSADM.CROSS001 ON SYSADM.CROSSCUR(
  ID)
/
CREATE  INDEX SYSADM.CROSS0012 ON SYSADM.CROSSCUR(
  ID_CUR1)
/
CREATE  INDEX SYSADM.CROSS0013 ON SYSADM.CROSSCUR(
  ID_CUR2)
/
ALTER TABLE SYSADM.CROSSCUR FOREIGN KEY CU100403 (
  ID_CUR1 ) REFERENCES SYSADM.CURRENCY
/
ALTER TABLE SYSADM.CROSSCUR FOREIGN KEY CU100404 (
  ID_CUR2 ) REFERENCES SYSADM.CURRENCY
/

CREATE PUBLIC SYNONYM CROSSCUR FOR SYSADM.CROSSCUR
/


CREATE TABLE SYSADM.REMAINDET (
  ROW_DATE DATE NOT NULL, 
  ID_ACC VARCHAR(18) NOT NULL, 
  ID_AN VARCHAR(18) NOT NULL, 
  REM_ACC DOUBLE PRECISION, 
  REM_quanti DOUBLE PRECISION, 
  REM_MANEY VARCHAR(18) NOT NULL)
/

CREATE UNIQUE INDEX SYSADM.BIGIND1404 ON SYSADM.REMAINDET(
  ROW_DATE, 
  ID_ACC, 
  ID_AN, 
  REM_MANEY)
/
CREATE INDEX SYSADM.INDREM02 ON SYSADM.REMAINDET(
  ID_ACC)
/
CREATE INDEX SYSADM.INDREM03 ON SYSADM.REMAINDET(
  ID_AN)
/
CREATE INDEX SYSADM.INDREM04 ON SYSADM.REMAINDET(
  REM_MANEY)
/
CREATE INDEX SYSADM.INDREM05 ON SYSADM.REMAINDET(
  ROW_DATE)
/
CREATE INDEX SYSADM.INDREM06 ON SYSADM.REMAINDET(
  REM_ACC)
/
CREATE INDEX SYSADM.INDREM07 ON SYSADM.REMAINDET(
  REM_quanti )
PCTFREE 10
/
CREATE PUBLIC SYNONYM REMAINDET FOR SYSADM.REMAINDET
/

ALTER TABLE SYSADM.REMAINDET  FOREIGN KEY Rem100401 (
  ID_ACC ) REFERENCES SYSADM.PLAN_ACCOUNT
/
ALTER TABLE SYSADM.REMAINDET  FOREIGN KEY Rem100402 (
  ID_AN) REFERENCES SYSADM.SUBCONTO
/
ALTER TABLE SYSADM.REMAINDET  FOREIGN KEY Rem100403 (
  REM_MANEY  ) REFERENCES SYSADM.CURRENCY
/

STORE SYSADM.STRSELREM select a.ROW_DATE, a.REM_ACC, a.REM_quanti, a.REM_MANEY     
 from remaindet a     
where  a.ID_acc=:2 AND     
a.ID_an=:3 AND a.REM_MANEY=:4     
AND  a.ROW_DATE in     
(select max ( b.ROW_DATE )  from REMAINDET b where     
b.ROW_DATE <=  :1 and b.ID_ACC = :2 and b.ID_AN = :3 and b.REM_MANEY = :4 )   
/

STORE SYSADM.STRINSREM insert into Remaindet
( ROW_DATE, ID_ACC, ID_AN, REM_ACC, REM_quanti, REM_MANEY  )
values (:1, :2, :3, :4, :5, :6 )
/
STORE SYSADM.STRUPREM update Remaindet set 
Rem_Acc  = Rem_Acc + :1,
 REM_quanti = REM_quanti + :2
 where ID_acc=:3 AND
 ID_an=:4 AND REM_MANEY =:5 AND
 ROW_DATE  >=   :6
/

STORE SYSADM.INSROWREM Procedure:  InsRowRem static
	Parameters
		Date/Time: RemDtW
		String: RemID_Acc
		String: RemID_AN
		Number: RemK
		Number: RemSum
		String: RemID_cur
	Local variables
		String: strSelWhere
		String: strSelInto
		String: strUpdWhere
		String: strUpRemOfr
		String: strUpFl
		String: strInsRemOld
		Number: Remfl
		Number: RemACC
		String: RemCur
		Number: RemKol
		String: Row
		String: NameTabl
		Number: nOk
		Date/Time: RemDat
		Sql Handle: hsqlWWW
		Number: nCount
		Number: bInsert
	Actions
	   On Procedure Startup
                Call SqlConnect ( hsqlWWW )
	   On Procedure Execute
		set NameTabl = 'remaindet'
		Set RemACC = 0
		Set RemKol = 0
		Set bInsert = 1
		Set strSelWhere = ' :RemDtW, :RemID_Acc, :RemID_AN, :RemID_cur '
		Set strSelInto = ' :RemDat, :RemACC, :RemKol,  :Remfl '
		Set strUpdWhere = ' :RemSum, :RemK, :RemID_Acc, :RemID_AN, :RemID_cur, :RemDtW '
		Set strInsRemOld = ' :RemDtW, :RemID_Acc, :RemID_AN, :RemACC, :RemKol, :RemID_cur '

		When SqlError
			Set nOk = SqlError ( hsqlWWW )
			Return FALSE

		Call SqlRetrieve(hsqlWWW, 'sysadm.strSelRem', strSelWhere, strSelInto )
		Call SqlExecute(hsqlWWW)
		Call SqlGetResultSetCount ( hsqlWWW, nCount )
		If nCount >0
			Call SqlFetchNext(hsqlWWW, nOk)
			If RemDtW = RemDat
				Set bInsert = 0
		If bInsert = 1
			Call SqlRetrieve(hsqlWWW, 'sysadm.strInsRem', strInsRemOld,'')
			Call SqlExecute(hsqlWWW)
		Call SqlRetrieve(hsqlWWW,'sysadm.strUpRem', strUpdWhere,'')
		Call SqlExecute(hsqlWWW)
	   On Procedure Close
		Call SqlDisconnect ( hsqlWWW )
/

STORE SYSADM.INS_ROWBGREM Procedure:  Ins_RowBgRem static
	Parameters
		String: GBmaxID
		String: strRoWid
		Date/Time: GBdat
		String: my_d_acc
		String: my_k_acc
		String: my_an_d
		String: my_an_k
		Number: GB_k
		Number: my_sum_row
		String: GBid_cur
	Local variables
		String: strInsP
		Number: nOk
		Number: tmp_Qw
		Number: tmp_Sum
		Sql Handle: hsqlWWW
		Number: nChoose
		String: OperNow
	Actions
 	   On Procedure Startup
                Call SqlConnect ( hsqlWWW )
	   On Procedure Execute
		Set OperNow = 'I'

		When SqlError
			Set nOk = SqlError ( hsqlWWW )
			Return FALSE

		Call SqlRetrieve(hsqlWWW, 'sysadm.GetMaxID', ' :NameTabl, :GBmaxID ', ' :GBmaxID ')
		Call SqlExecute ( hsqlWWW )
		Call SqlFetchRow ( hsqlWWW, 0, nChoose )
		Call SqlRetrieve(hsqlWWW, 'InsRowRem', ' :GBdat, :my_d_acc, :my_an_d, :GB_k, :my_sum_row, :GBid_cur ','')
		Call SqlExecute ( hsqlWWW )
		set tmp_Qw  =  -GB_k
		set tmp_Sum =  -my_sum_row
		Call SqlRetrieve(hsqlWWW, 'InsRowRem', ' :GBdat, :my_k_acc, :my_an_k, :tmp_Qw,  :tmp_Sum, :GBid_cur ','')
		Call SqlExecute ( hsqlWWW )
	   On Procedure Close
                Call SqlDisconnect ( hsqlWWW )
/


CREATE TRIGGER SYSADM.INSROWGB After Insert  ON SYSADM.GROS_BUCH
(Execute SYSADM.INS_ROWBGREM
(
 GROS_BUCH.ID,
 GROS_BUCH.rowid,
 GROS_BUCH.ROW_DATE,
 GROS_BUCH.ID_D_ACC,
 GROS_BUCH.ID_K_ACC,
 GROS_BUCH.ID_AN_D,
 GROS_BUCH.ID_AN_K,
 GROS_BUCH.quanti_ROW,
 GROS_BUCH.Money_ROW,
 GROS_BUCH.ID_CUR   ))
 For Each Row

/

STORE SYSADM.UPPR_GRBU Procedure:  UpPr_GrBu static
	Parameters
		Date/Time: NewROW_DAT
		string: NewID_D_ACC
		string: NewID_K_ACC
		Number: NewSUM_ROW
		Number: NewK_REM
		string: NewID_CUR
		string: NewID_AN_D
		string: NewID_AN_K
		String: strRoWid
		string:  ID
		Date/Time: ROW_DAT
		string:  ID_D_ACC
		string:  ID_K_ACC
		string:  DEFINIT
		Number: SUM_ROW
		Number: K_REM
		string:  NUMJOURNAL
		string:  ID_CUR
		string:  ID_AN_D
		string:  ID_AN_K
		string:  ID_DOC
		string:  ID_STR_DOC
		string:  ID_USER
	Local variables
		Sql Handle: hsqlWWW
		Number: tmp_Qw
		Number: tmp_Sum
		Number: nOk
		String: OperNow
	Actions
 	   On Procedure Startup
                Call SqlConnect ( hsqlWWW )
	   On Procedure Execute

		When SqlError
			Set nOk = SqlError ( hsqlWWW )
			Return FALSE

!	   ,    ,      ""
		set tmp_Qw  =  -K_REM
		set tmp_Sum =  -SUM_ROW
		Call SqlRetrieve(hsqlWWW, 'InsRowRem', ' :ROW_DAT, :ID_D_ACC, :ID_AN_D, :tmp_Qw,  :tmp_Sum, :ID_CUR ','')
		Call SqlExecute ( hsqlWWW )
		Call SqlRetrieve(hsqlWWW, 'InsRowRem', ' :ROW_DAT, :ID_K_ACC, :ID_AN_K,  :K_REM,  :SUM_ROW,  :ID_CUR ','')
		Call SqlExecute ( hsqlWWW )

!         ....
!		Set OperNow = 'U'
!		Call SqlImmediate ( ' insert into  SYSREP.DT$GROS_BUCH 	select ID, ROW_DATE, ID_D_ACC, ID_K_ACC, DEFIneRow, Money_ROW, quanti_ROW, NUMJOURNAL, ID_CUR, ID_AN_D, ID_AN_K, ID_DOC, ID_STR_DOC, ID_USER,  :OperNow, current timestamp from SYSADM.GROS_BUCH where rowid = :strRoWid ' )

!   "  -   "",       .... 
		set tmp_Qw  =  -NewK_REM
		set tmp_Sum =  -NewSUM_ROW
		Call SqlRetrieve(hsqlWWW, 'InsRowRem', ' :NewROW_DAT, :NewID_D_ACC, :NewID_AN_D, :NewK_REM, :NewSUM_ROW, :NewID_CUR ','')
		Call SqlExecute ( hsqlWWW )
		Call SqlRetrieve(hsqlWWW, 'InsRowRem', ' :NewROW_DAT, :NewID_K_ACC, :NewID_AN_K, :tmp_Qw,  :tmp_Sum, :NewID_CUR ','')
		Call SqlExecute ( hsqlWWW )

	   On Procedure Close
                Call SqlDisconnect ( hsqlWWW )
/

CREATE TRIGGER SYSADM.UPD_GBU Before Update  ON SYSADM.GROS_BUCH
REFERENCING OLD  oldT  NEW NewT ( 
Execute SYSADM.UpPr_GrBu (
NewT.ROW_DATE, NewT.ID_D_ACC, NewT.ID_K_ACC, 
NewT.Money_ROW,  NewT.quanti_ROW,  
NewT.ID_CUR, NewT.ID_AN_D, NewT.ID_AN_K, NewT.rowid,
oldT.ID, oldT.ROW_DATE, oldT.ID_D_ACC, oldT.ID_K_ACC,  
oldT.DEFIneRow, oldT.Money_ROW,  oldT.quanti_ROW,
oldT.NUMJOURNAL, oldT.ID_CUR, oldT.ID_AN_D, oldT.ID_AN_K,  
oldT.ID_DOC, oldT.ID_STR_DOC, oldT.ID_USER  ))
 For Each Row

/

STORE SYSADM.DELL_ROWBGREM Procedure:  Dell_RowBgRem static
	Parameters
		String: strRoWid
		string:  ID
		Date/Time: ROW_DAT
		string:  ID_D_ACC
		string:  ID_K_ACC
		string:  DEFINIT
		Number: SUM_ROW
		Number: K_REM
		string:  NUMJOURNAL
		string:  ID_CUR
		string:  ID_AN_D
		string:  ID_AN_K
		string:  ID_DOC
		string:  ID_STR_DOC
		string:  ID_USER
	Local variables
		String: strInsP
		Number: GBmaxID
		Number: nOk
		Number: tmp_Qw
		Number: tmp_Sum
		Sql Handle: hsqlWWW
		Number: nChoose
		string:  OPER
	Actions
 	   On Procedure Startup
                Call SqlConnect ( hsqlWWW )
	   On Procedure Execute

		When SqlError
			Set nOk = SqlError ( hsqlWWW )
			Return FALSE

		set tmp_Qw  =  -K_REM
		set tmp_Sum =  -SUM_ROW
		Call SqlRetrieve(hsqlWWW, 'InsRowRem', ' :ROW_DAT, :ID_D_ACC, :ID_AN_D, :tmp_Qw,  :tmp_Sum, :ID_CUR ','')
		Call SqlExecute ( hsqlWWW )
		Call SqlRetrieve(hsqlWWW, 'InsRowRem', ' :ROW_DAT, :ID_K_ACC, :ID_AN_K,  :K_REM,  :SUM_ROW,  :ID_CUR ','')
		Call SqlExecute ( hsqlWWW )

!		Set OPER = 'D'
!  ,        -      " ".... -  , , "  " :-)....

	   On Procedure Close
                Call SqlDisconnect ( hsqlWWW )
/

CREATE TRIGGER SYSADM.DEL_GB
Before DELETE  ON SYSADM.GROS_BUCH ( Execute SYSADM.Dell_RowBgRem (
rowid, ID, ROW_DATE, 
ID_D_ACC, ID_K_ACC, DEFIneRow, 
Money_ROW,  quanti_ROW, 
NUMJOURNAL, ID_CUR, ID_AN_D, ID_AN_K,  ID_DOC, ID_STR_DOC, ID_USER ))
 For Each Row
/

